'use strict';

/* should be exported before require of interpret */

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

module.exports = interpretList;

var currify = require('currify/legacy');

var swap = currify(function (fn, a, b) {
    return fn(b, a);
});
var interpret = swap(require('./interpret'));
var Context = require('./context');
var library = require('./library');

var head = library.head;
var tail = library.tail;

var isFunction = function isFunction(fn) {
    return typeof fn === 'function';
};

var special = {
    const: function _const(input, context) {
        var constContext = input[1].reduce(function (acc, x) {
            acc.scope[x[0].value] = interpret(x[1], context);

            return acc;
        }, new Context({}, context));

        return interpret(input[2], constContext);
    },

    lambda: function lambda(input, context) {
        return function () {
            for (var _len = arguments.length, lambdaArguments = Array(_len), _key = 0; _key < _len; _key++) {
                lambdaArguments[_key] = arguments[_key];
            }

            var lambdaScope = input[1].reduce(function (acc, x, i) {
                acc[x.value] = lambdaArguments[i];
                return acc;
            }, {}),
                newContext = new Context(lambdaScope, context);

            return interpret(input[2], newContext);
        };
    },

    if: function _if(input, context) {
        var _input = _slicedToArray(input, 4),
            first = _input[1],
            second = _input[2],
            third = _input[3];

        if (interpret(first, context)) return interpret(second, context);

        interpret(third, context);
    }
};

var checkFunction = function checkFunction(name, value) {
    if (!isFunction(value)) throw Error(name + ' is not a function!');
};

function interpretList(input, context) {
    var first = head(input);

    if (input.length && first.value in special) return special[first.value](input, context);

    var _input2 = _slicedToArray(input, 1),
        fnData = _input2[0];

    var list = input.map(interpret(context));
    var fn = head(list);

    checkFunction(fnData.value, fn);

    return fn.apply(undefined, _toConsumableArray(tail(list)));
}