'use strict';

module.exports = interpret;

var Context = require('./context');
var library = require('./library');
var interpretList = require('./interpret-list');

var isArray = Array.isArray;


function interpret(input, context) {
    var ctx = context || new Context(library);

    if (isArray(input)) return interpretList(input, ctx);

    if (input.type === 'identifier') return ctx.get(input.value);

    // literal
    return input.value;
}